/*
 * Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

package samplethreadcounter.ra;

import javax.resource.NotSupportedException;
import javax.resource.ResourceException;
import javax.resource.spi.ActivationSpec;
import javax.resource.spi.BootstrapContext;
import javax.resource.spi.ResourceAdapter;
import javax.resource.spi.ResourceAdapterInternalException;
import javax.resource.spi.endpoint.MessageEndpointFactory;
import javax.resource.spi.work.WorkManager;

import samplethreadcounter.util.LogWrapper;



public class ResourceAdapterImpl 
    implements ResourceAdapter, java.io.Serializable
{

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static WorkManager         workManager;

    public static WorkManager getWorkManager() {
		return workManager;
	}

	/** 
     *	Constructor.
     */
    public ResourceAdapterImpl () {
	}
    
    /** 
     * Called by the AppServer to initialize the Resource Adapter.
     *
     * @param ctx  the BootstrapContext
     */
    public void start(BootstrapContext ctx) 
        throws ResourceAdapterInternalException
    {
		
        // Get Work Manager
        workManager = ctx.getWorkManager();
		if( workManager != null ) {
			LogWrapper.info( "getWorkManager: " + workManager.getClass().getName() ) ;
			MessageHandler.getInstance().setWorkManager(workManager);
		} else {
			LogWrapper.info( "getWorkManager is null!" ) ;
		}

    }

    public void stop() 
    {    
		LogWrapper.info( "RA stop()..." ) ;

    }
    
    public void endpointActivation (MessageEndpointFactory endpointFactory,
            			    ActivationSpec spec)
        throws NotSupportedException
    {            			                            
		LogWrapper.info( "endpointActivation  started..." ) ;
		
		MessageHandler.getInstance().setEndpointFactory(endpointFactory);

		
    }
    public void endpointDeactivation (MessageEndpointFactory endpointFactory, 
            			      ActivationSpec spec)
    {
    	MessageHandler.getInstance().setEndpointFactory(null);
    }
    
    public javax.transaction.xa.XAResource[] getXAResources(ActivationSpec[] specs)
                                                 throws ResourceException
    {
        throw new ResourceException("getXAResources is not supported.");
    }

}
