/*
 * Copyright 2004-2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

package samplethreadcounter.util;

import java.io.* ;

public class LogWrapper 
{

	static String log_file = null ;
	static boolean log_file_mode = false ;
	static FileWriter lfw = null ;
	public final static String lsp = System.getProperty("line.separator");

	static {
		log_file = System.getProperty( "samplethreadcounter.file" ) ;
		if( log_file != null ) {
			try {
				lfw = new FileWriter(log_file,true) ;
			} catch( IOException e ) {
				e.printStackTrace() ;
			}
		}

		if( lfw != null ) {
			log_file_mode = true ;
		}
	}

	public static void err(String info) 
    {
		if( log_file_mode ) {
			errorPrintln( info ) ;
		} else {
			System.err.println( info ) ;
		}
    }

	public static void debug(String info) 
    {
		if( log_file_mode ) {
			outPrintln( info ) ;
		} else {
			//System.out.println( info ) ;
		}
    }

	public static void info(String info) 
    {
		if( log_file_mode ) {
			outPrintln( info ) ;
		} else {
			System.out.println( info ) ;
		}
    }

	public static void dumpStack(Throwable e) 
    {
		if( log_file_mode ) {
			printStackTrace( e ) ;
		} else {
			e.printStackTrace() ;
		}
    }

	public static void errorPrintln(String info) 
    {
		try {
			lfw.write(info + lsp) ;
			lfw.flush() ;
		} catch( Exception ex ) {
			ex.printStackTrace() ;
		}
    }

	public static void outPrintln(String info) 
    {
		try {
			lfw.write(info + lsp) ;
			lfw.flush() ;
		} catch( Exception ex ) {
			ex.printStackTrace() ;
		}
    }

	public static void printStackTrace(Throwable e) 
    {
		try {
			StackTraceElement[] element = e.getStackTrace() ;
			
			for( int i =  0;i<element.length;i++ ) {
				lfw.write(element[i].toString() + lsp) ;
			}
			lfw.flush() ;
		} catch( Exception ex ) {
			ex.printStackTrace() ;
		}
    }
}
