package samplethreadcounter.web;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import samplethreadcounter.util.LogWrapper;

public class ParameterServlet {


	private int startTimeout = 5000;
	private int workRunningTime = 3;

	private int workNum = 5;
	
	private String methodName ;
	private String threadPoolName ;

	private boolean isWorkActionWithPara;
	
	private boolean isWorkListenerNull = false;
	private boolean isExecutionContextNull = true;
	private boolean isExceptionInRun = false;
	
	public boolean isExceptionInRun() {
		return isExceptionInRun;
	}

	public void setExceptionInRun(boolean isExceptionInRun) {
		this.isExceptionInRun = isExceptionInRun;
	}

	public ParameterServlet(HttpServletRequest req) throws ServletException {
		super();
		// TODO Auto-generated constructor stub
		

		String withPara = req.getParameter("withPara");
		if("on".equals(withPara)){
			this.isWorkActionWithPara = true;
		}
		
		if("on".equals(req.getParameter("withExecutionContext"))){
			this.isExecutionContextNull = false;
		}

		//listener is on be default
		if("off".equals(req.getParameter("withWorkListener"))){
			this.isWorkListenerNull = true;
		}
		
		if("on".equals(req.getParameter("withWorkException"))){
			this.isExceptionInRun = true;
		}
		

		threadPoolName = req.getParameter("threadPoolName") ;
		LogWrapper.info("poolName is  " + threadPoolName );
		
		if(threadPoolName == null){
			//LogWrapper.info("poolName is not specified. Use default thread pool.");
			threadPoolName = "thread-pool-1";
		}

		
		methodName = req.getParameter("submitButton");
		
		this.startTimeout = UtilityServlet.getIntValue(req.getParameter("startTimeout"), 5000);
		this.workRunningTime = UtilityServlet.getIntValue(req.getParameter("workRunningTime"), 5);
		this.workNum = UtilityServlet.getIntValue(req.getParameter("workNum"), 5);
		
	}

	public int getStartTimeout() {
		return startTimeout;
	}

	public void setStartTimeout(int startTimeout) {
		this.startTimeout = startTimeout;
	}

	public int getWorkRunningTime() {
		return workRunningTime;
	}

	public void setWorkRunningTime(int workRunningTime) {
		this.workRunningTime = workRunningTime;
	}

	public int getWorkNum() {
		return workNum;
	}

	public void setWorkNum(int workNum) {
		this.workNum = workNum;
	}

	public String getMethodName() {
		return methodName;
	}

	public void setMethodName(String methodName) {
		this.methodName = methodName;
	}

	public String getThreadPoolName() {
		return threadPoolName;
	}

	public void setThreadPoolName(String threadPoolName) {
		this.threadPoolName = threadPoolName;
	}

	public boolean isWorkActionWithPara() {
		return isWorkActionWithPara;
	}

	public void setWorkActionWithPara(boolean isWorkActionWithPara) {
		this.isWorkActionWithPara = isWorkActionWithPara;
	}

	public boolean isWorkListenerNull() {
		return isWorkListenerNull;
	}

	public void setWorkListenerNull(boolean isWorkListenerNull) {
		this.isWorkListenerNull = isWorkListenerNull;
	}

	public boolean isExecutionContextNull() {
		return isExecutionContextNull;
	}

	public void setExecutionContextNull(boolean isExecutionContextNull) {
		this.isExecutionContextNull = isExecutionContextNull;
	}

	
}
