/*
 * HelloServlet.java
 * Servlet/JSP Sample Application
 * HelloServlet : Servlet class
 * 
 * Copyright (c) 2004 FUJITSU LIMITED All Rights Reserved.
 */
package samplethreadcounter.web;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.RandomAccessFile;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import samplethreadcounter.util.LogWrapper;



public class UtilityServlet {

	public static void printRequest(HttpServletRequest req){
		Enumeration<String> e = req.getParameterNames();

		LogWrapper.info("************ Request parameters *************** " );
		while(e.hasMoreElements()){
			String name = e.nextElement();
			String value = req.getParameter(name);
			LogWrapper.info(" --- " + name + " --- " + value);
			
		}
		LogWrapper.info("*********************************************** " );

	}
	
	public static String getMethodName(HttpServletRequest req){

		
		String methodName = req.getParameter("methodName");
		if(methodName == null || methodName.trim().length() == 0){
			
			String buttonName = req.getParameter("submitButton");
			if(buttonName == null){
				LogWrapper.info("Cannot run test. 'methodName' must be specified in GET mode.");
				return null;
			}
			else{
				methodName = buttonName;
			}
		}
		else{
			LogWrapper.info("Run method: " + methodName );
		}
		return methodName;
	}
	
	
	public static int getIntValue(String parameter, int defaultValue){

		int value;
		if(parameter != null){
			try{
				value = new Integer(parameter);
			}
			catch(Exception e){
				value = defaultValue;
			};
		}
		else{
			value =  defaultValue;
		}
		return value;
	}
	
	public static void callMethodInServlet(String methodName, Object servlet) throws SecurityException, NoSuchMethodException, IllegalArgumentException, IllegalAccessException, InvocationTargetException {
		// TODO Auto-generated method stub
		Class[] cls = null;
		Method myMethod = servlet.getClass().getMethod(methodName, cls);

		Object[] obj = null;
		myMethod.invoke(servlet, obj);

	}
	

}
